package org.acmestudio.example.externalanalysis;

import java.util.List;
import java.util.Stack;

import org.acmestudio.acme.core.IAcmeType;
import org.acmestudio.acme.element.IAcmeElement;
import org.acmestudio.acme.environment.error.AcmeError;
import org.acmestudio.acme.rule.node.IExternalAnalysisExpressionNode;
import org.acmestudio.acme.rule.node.feedback.AcmeExpressionEvaluationException;

public class NiftyAnalysis implements IExternalAnalysisExpressionNode {

	public Object evaluate(IAcmeType requestedType, List<Object> arguments,
			Stack<AcmeError> errorStack)
			throws AcmeExpressionEvaluationException {
		if (arguments.size() != 2) {
			AcmeError err = new AcmeError();
			err
					.setMessageSource("This design analysis was called with other than two arguments! Bad invoker!");
			errorStack.add(err);
			throw new AcmeExpressionEvaluationException();
		}
		Object o1 = arguments.get(0);
		Object o2 = arguments.get(1);
		
		if (!(o1 instanceof IAcmeElement)) {
			AcmeError err = new AcmeError();
			err
					.setMessageSource("This design analysis was called with something other than an IAcmeElement as the first argument! Bad invoker!");
			errorStack.add(err);
			throw new AcmeExpressionEvaluationException();
		}
		if (!(o2 instanceof IAcmeElement)) {
			AcmeError err = new AcmeError();
			err
					.setMessageSource("This design analysis was called with something other than an IAcmeElement as the second argument! Bad invoker!");
			errorStack.add(err);
			throw new AcmeExpressionEvaluationException();
		}
		String name1 = ((IAcmeElement)o1).getName();
		String name2 = ((IAcmeElement)o2).getName();

		if (name1 == null || name1.length() == 0) {
			AcmeError err = new AcmeError();
			err
					.setMessageSource("This design analysis was called with something (first argument) that has a null or zero-length name! Bad invoker!");
			errorStack.add(err);
			throw new AcmeExpressionEvaluationException();
		}

		if (name2 == null || name2.length() == 0) {
			AcmeError err = new AcmeError();
			err
					.setMessageSource("This design analysis was called with something (second argument) that has a null or zero-length name! Bad invoker!");
			errorStack.add(err);
			throw new AcmeExpressionEvaluationException();
		}

		// PLEASE NOTE: THIS IS A LAME - ASS DELIBERATELY INCREDIBLY INEFFICIENT STRING REVERSAL ALGORITHM.
		// IF ANYTHING LIKE THIS IS EVER USED AS ANYTHING BUT AN EXAMPLE, YOU WILL BE MOCKED. REPEATEDLY.
		
		StringBuffer sb = new StringBuffer("");
		for(int i=name1.length(); i>=1; i--) {
			sb.append(name1.substring(i-1,i));
		}
		return (name2.equals(sb.toString()) ? Boolean.TRUE : Boolean.FALSE);
	}
}
